/**
 * @file
 *
 * AMD Family_10 Microcode patch.
 *
 * Fam10 Microcode Patch rev 010000c4 for 1081 or equivalent.
 *
 * @xrefitem bom "File Content Label" "Release Content"
 * @e project:      AGESA
 * @e sub-project:  CPU/FAMILY/0x10/REVD
 * @e \$Revision$   @e \$Date$
 *
 */
/*
 ******************************************************************************
 *
 * Copyright (c) 2011, Advanced Micro Devices, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Advanced Micro Devices, Inc. nor the names of
 *       its contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL ADVANCED MICRO DEVICES, INC. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ******************************************************************************
 */
/*----------------------------------------------------------------------------------------
 *                             M O D U L E S    U S E D
 *----------------------------------------------------------------------------------------
 */
#include "AGESA.h"
#include "cpuRegisters.h"
#include "cpuEarlyInit.h"

/*----------------------------------------------------------------------------------------
 *                   D E F I N I T I O N S    A N D    M A C R O S
 *----------------------------------------------------------------------------------------
 */

/*----------------------------------------------------------------------------------------
 *                  T Y P E D E F S     A N D     S T R U C T U R E S
 *----------------------------------------------------------------------------------------
 */

// Patch code 010000c4 for 1081 and equivalent
CONST MICROCODE_PATCHES ROMDATA CpuF10MicrocodePatch010000c4 =
{
{
0x10,
0x20,
0x03,
0x03,
0xc4,
0x00,
0x00,
0x01,
0x00,
0x80,
0x20,
0x01,
0x4a,
0xe0,
0x9c,
0x93,
0x00,
0x00,
0x00,
0x00,
0x00,
0x00,
0x00,
0x00,
0x81,
0x10,
0x00,
0x00,
0x00,
0xaa,
0xaa,
0xaa,
0xa7,
0x0b,
0x00,
0x00,
0x14,
0x0c,
0x00,
0x00,
0x55,
0x03,
0x00,
0x00,
0xff,
0xff,
0xff,
0xff,
0x51,
0x03,
0x00,
0x00,
0xff,
0xff,
0xff,
0xff,
0xff,
0xff,
0xff,
0xff,
0xff,
0xff,
0xff,
0xff,
0x4f,
0xdf,
0x38,
0x00,
0x81,
0x3f,
0x20,
0xc0,
0x4e,
0xf0,
0xff,
0xbf,
0x0f,
0xff,
0x5e,
0x3f,
0xf0,
0xdf,
0xad,
0x07,
0x3d,
0xf8,
0x7b,
0x7b,
0xc0,
0x00,
0xd4,
0x00,
0x13,
0xf1,
0xff,
0xff,
0xac,
0xe1,
0x1f,
0xe0,
0x4e,
0xfe,
0xbb,
0xff,
0xfe,
0x87,
0x7f,
0xa7,
0x03,
0xf8,
0x7f,
0xd6,
0x7c,
0x1e,
0xfa,
0xbd,
0x00,
0xe0,
0xff,
0x7b,
0x0e,
0x00,
0x3d,
0x57,
0xe0,
0x73,
0xd0,
0x0f,
0xff,
0x2e,
0xfe,
0xff,
0xc0,
0xcf,
0xc3,
0x3f,
0xeb,
0x01,
0xfc,
0x77,
0x5a,
0x3e,
0x0f,
0xfd,
0x35,
0x00,
0x90,
0x3e,
0xff,
0x9f,
0xe0,
0xfd,
0x65,
0x60,
0x75,
0xf8,
0x9f,
0xff,
0x97,
0xff,
0x1f,
0xe0,
0xe7,
0xe1,
0x03,
0xf5,
0xde,
0xff,
0x7e,
0x2c,
0x9f,
0x87,
0xff,
0x1e,
0x00,
0xf8,
0x6f,
0x95,
0x03,
0x50,
0xf4,
0x03,
0xf8,
0x1c,
0xf8,
0xff,
0x3f,
0x00,
0xf0,
0xee,
0x84,
0xfc,
0xfe,
0xff,
0xff,
0x22,
0xc3,
0x1f,
0x51,
0x96,
0x38,
0x16,
0x0d,
0x00,
0xf8,
0xfe,
0xfe,
0x01,
0x0e,
0xfc,
0xb1,
0x01,
0xe5,
0xa6,
0xff,
0x1f,
0x79,
0xf8,
0x07,
0xf8,
0x80,
0xff,
0xc0,
0x3f,
0xbf,
0xe1,
0x1f,
0xc0,
0x00,
0xfa,
0xbf,
0x07,
0x01,
0xfc,
0x3f,
0xe3,
0x3e,
0x0f,
0xfd,
0x50,
0x03,
0xb0,
0xdf,
0x8c,
0xf9,
0x3c,
0xf4,
0x43,
0x0e,
0xc0,
0xfd,
0x32,
0xe5,
0xf3,
0xd0,
0x0f,
0x03,
0x00,
0x03,
0x25,
0xff,
0x00,
0xfe,
0x03,
0x00,
0xff,
0x86,
0x7f,
0xfc,
0x03,
0xf8,
0x0f,
0x01,
0xfc,
0x1b,
0xfe,
0xf0,
0x0f,
0xe0,
0x3f,
0x07,
0xf0,
0x6f,
0xf8,
0xef,
0x01,
0x80,
0xff,
0xff,
0xff,
0x00,
0xfd,
0xbb,
0x14,
0xf2,
0xc3,
0x2f,
0xf8,
0x13,
0xcc,
0x7f,
0x0c,
0xb8,
0x0e,
0x74,
0xf5,
0x03,
0xf0,
0xf8,
0x33,
0x03,
0x1c,
0x2b,
0xd7,
0x00,
0x00,
0xeb,
0xe5,
0x1f,
0x80,
0xc0,
0x1f,
0x1b,
0xe0,
0x9e,
0x9b,
0x7f,
0x00,
0x03,
0x7f,
0x6c,
0x80,
0xf8,
0x7d,
0xfe,
0x01,
0x0e,
0xfc,
0xb1,
0x01,
0x80,
0xd7,
0x62,
0x00,
0xc0,
0x7f,
0xe0,
0x1f,
0xdf,
0xf0,
0x0f,
0xe0,
0x00,
0xff,
0x81,
0x7f,
0x7f,
0xc3,
0x3f,
0x80,
0x01,
0xfc,
0x07,
0xfe,
0xfe,
0x0d,
0xff,
0x00,
0x00,
0xf0,
0xff,
0x3d,
0x0f,
0xe0,
0x3f,
0xf0,
0xf0,
0x6f,
0xf8,
0x07,
0x3f,
0x80,
0xff,
0xc0,
0xc0,
0xbf,
0xe1,
0x1f,
0xff,
0x00,
0xfe,
0x03,
0x00,
0xff,
0x86,
0x7f,
0x1e,
0x00,
0xf8,
0xff,
0xf8,
0x07,
0xf0,
0x1f,
0x03,
0xf8,
0x37,
0xfc,
0xe0,
0x1f,
0xc0,
0x7f,
0x0f,
0xe0,
0xdf,
0xf0,
0x81,
0x7f,
0x00,
0xff,
0x3f,
0x80,
0x7f,
0xc3,
0x7f,
0x0f,
0x00,
0xfc,
0x0f,
0xfc,
0x03,
0xf8,
0xfe,
0x01,
0xfc,
0x1b,
0x3f,
0xf0,
0x0f,
0xe0,
0xf8,
0x07,
0xf0,
0x6f,
0xff,
0xc0,
0x3f,
0x80,
0xe1,
0x1f,
0xc0,
0xbf,
0xfe,
0xbf,
0x07,
0x00,
0xfc,
0x07,
0xfe,
0x01,
0x0d,
0xff,
0x00,
0xfe,
0xf0,
0x1f,
0xf8,
0x07,
0x37,
0xfc,
0x03,
0xf8,
0xc0,
0x7f,
0xe0,
0x1f,
0xdf,
0xf0,
0x0f,
0xe0,
0x00,
0xff,
0xdf,
0x03,
0x00,
0xfe,
0x03,
0xff,
0xff,
0x86,
0x7f,
0x00,
0x03,
0xf8,
0x0f,
0xfc,
0xfc,
0x1b,
0xfe,
0x01,
0x0f,
0xe0,
0x3f,
0xf0,
0xf0,
0x6f,
0xf8,
0x07,
0x01,
0x80,
0xff,
0xef,
0x38,
0x00,
0x43,
0xdf,
0xa0,
0xd7,
0x83,
0x3f,
0xe3,
0x00,
0x3c,
0x75,
0x80,
0x5e,
0x07,
0xfe,
0xff,
0xef,
0x7a,
0xc1,
0x73,
0xfd,
0x3c,
0xfc,
0xf7,
0x00,
0xc0,
0xff,
0xff,
0xff,
0x17,
0xff,
0xdf,
0xeb,
0xff,
0xe1,
0xb7,
0xf5,
0x00,
0xfe,
0x7f,
0x6e,
0x80,
0x07,
0xff,
0xff,
0x6f,
0x11,
0xfe,
0xb5,
0xaa,
0x1f,
0xff,
0x7b,
0x00,
0xe0,
0xff,
0xff,
0x7f,
0x8b,
0xf0,
0xaf,
0x75,
0xff,
0xff,
0xdb,
0x7f,
0x2f,
0xc3,
0xbf,
0x57,
0xf5,
0x0c,
0xf1,
0xff,
0xb7,
0x0f,
0xff,
0x00,
0x3f,
0x70,
0xa2,
0x35,
0x00,
0xe0,
0xff,
0x1b,
0x0f,
0x79,
0xe8,
0xd7,
0xf2,
0x80,
0xff,
0xc0,
0x3f,
0xbf,
0xe1,
0x1f,
0xc0,
0x00,
0xfe,
0x03,
0xff,
0xff,
0x86,
0x7f,
0x00,
0x00,
0xf8,
0xff,
0x1e,
0x2f,
0x3a,
0xc1,
0xff,
0xfd,
0x3c,
0xfc,
0x6b,
0x1e,
0xc0,
0x7f,
0xb6,
0x0c,
0xf0,
0xe0,
0x4f,
0xff,
0x2f,
0x43,
0xfc,
0xc0,
0xcf,
0xc3,
0x3f,
0x0f,
0x00,
0xfc,
0x7f,
0xff,
0x67,
0x81,
0xff,
0xb1,
0xee,
0x1f,
0xfe,
0x1b,
0x0f,
0xe0,
0xff,
0xf7,
0xf6,
0x7a,
0xf0,
0xef,
0xbf,
0x96,
0xff,
0x1d,
0xab,
0xfe,
0xe1,
0xbf,
0x07,
0x00,
0xfe,
0x6f,
0xff,
0xb1,
0xfc,
0x7f,
0x58,
0x59,
0x0e,
0xc0,
0xff,
0x2f,
0x72,
0xfc,
0x03,
0xfc,
0x3c,
0x7f,
0x31,
0x1e,
0xc0,
0xe0,
0x4f,
0xec,
0x75,
0xff,
0xdf,
0x03,
0x00,
0xd7,
0xf8,
0xff,
0x45,
0x87,
0x7f,
0xa2,
0x9f,
0x19,
0xff,
0xff,
0x67,
0x1f,
0xfe,
0xb1,
0xae,
0x65,
0xfc,
0xff,
0xff,
0x7e,
0xf8,
0xf7,
0xba,
0x80,
0xff,
0xef,
0x01,
0x00,
0xff,
0xdb,
0x7a,
0xc0,
0x83,
0x3f,
0x31,
0x01,
0xfc,
0x67,
0xff,
0xf4,
0x0f,
0xdf,
0x5a,
0x4f,
0xf0,
0xff,
0xff,
0xd8,
0x3a,
0xfc,
0x32,
0x00,
0xc0,
0x01,
0x48,
0x7f,
0x97,
0xf1,
0xff,
0xe0,
0xac,
0xe1,
0x1f,
0xff,
0x5a,
0xfe,
0xbb,
0xad,
0xff,
0x87,
0x7f,
0xfe,
0x03,
0xf8,
0xff,
0xb5,
0xe8,
0x1f,
0xbe,
0x7b,
0x00,
0xe0,
0xff,
0xe0,
0x5f,
0xcb,
0x7f,
0xab,
0x75,
0xe5,
0xf0,
0xdb,
0x7a,
0x00,
0xff,
0x3f,
0x91,
0xcf,
0x43,
0x0f,
0xf8,
0x13,
0x90,
0xbf,
0x0c,
0xb6,
0x0e,
0xff,
0x3d,
0x00,
0xf0,
0x7f,
0x5b,
0x0f,
0xe0,
0xf0,
0x27,
0x06,
0x78,
0xff,
0xc0,
0x3f,
0x80,
0xe1,
0x5b,
0x8b,
0xfe,
0xca,
0x07,
0xfc,
0x09,
0x87,
0x5f,
0x06,
0x5b,
0x20,
0x00,
0x09,
0x00,
0xb0,
0xc0,
0x8d,
0x03,
0x3c,
0xf8,
0x03,
0x02,
0x80,
0xf8,
0xff,
0x3f,
0xfc,
0xf0,
0xce,
0x85,
0x04,
0x3a,
0x0e,
0xfe,
0xae,
0xc3,
0x1f,
0x03,
0x00,
0xfc,
0x7f,
0x0f,
0x77,
0x01,
0x00,
0xf8,
0xee,
0x1f,
0xfe,
0xb9,
0x3f,
0x65,
0x40,
0xe0,
0xf8,
0x79,
0xf8,
0x07,
0xff,
0x94,
0xf3,
0xff,
0xea,
0xfa,
0xe0,
0x5f,
0x06,
0x00,
0x7a,
0xbc,
0xff,
0xa5,
0xfe,
0x77,
0x52,
0x3f,
0x0f,
0xff,
0xff,
0xef,
0xf2,
0xfe,
0x03,
0xfc,
0x3c,
0xfc,
0x77,
0x1f,
0xe0,
0x7f,
0x2f,
0xe5,
0xf3,
0xd0,
0xdf,
0x03,
0x00,
0xff,
0x03,
0xff,
0x00,
0xfe,
0x7f,
0x00,
0xff,
0x86,
0x0f,
0xfc,
0x03,
0xf8,
0xfe,
0x01,
0xfc,
0x1b,
0x3f,
0xf0,
0x0f,
0xe0,
0xf8,
0x07,
0xf0,
0x6f,
0xff,
0xef,
0x01,
0x80
}
};

/*----------------------------------------------------------------------------------------
 *           P R O T O T Y P E S     O F     L O C A L     F U N C T I O N S
 *----------------------------------------------------------------------------------------
 */

/*----------------------------------------------------------------------------------------
 *                          E X P O R T E D    F U N C T I O N S
 *----------------------------------------------------------------------------------------
 */
