#*****************************************************************************
#
# Copyright (c) 2012, Advanced Micro Devices, Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of Advanced Micro Devices, Inc. nor the names of
#       its contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL ADVANCED MICRO DEVICES, INC. BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#*****************************************************************************

# AGESA V5 Files
AGESA_ROOT = src/vendorcode/amd/agesa/f16kb

AGESA_INC =  -Isrc/mainboard/$(MAINBOARDDIR)
AGESA_INC += -I$(AGESA_ROOT)
AGESA_INC += -I$(AGESA_ROOT)/../common
AGESA_INC += -I$(AGESA_ROOT)/Include
AGESA_INC += -I$(AGESA_ROOT)/Legacy
AGESA_INC += -I$(AGESA_ROOT)/Proc/Common
AGESA_INC += -I$(AGESA_ROOT)/Proc/HT
AGESA_INC += -I$(AGESA_ROOT)/Proc/CPU
AGESA_INC += -I$(AGESA_ROOT)/Proc/CPU/Feature
AGESA_INC += -I$(AGESA_ROOT)/Proc/CPU/Family
AGESA_INC += -I$(AGESA_ROOT)/Proc/CPU/Family/0x16
AGESA_INC += -I$(AGESA_ROOT)/Proc/CPU/Family/0x16/KB
AGESA_INC += -I$(AGESA_ROOT)/Proc/Mem
AGESA_INC += -I$(AGESA_ROOT)/Proc/Mem/NB/KB
AGESA_INC += -I$(AGESA_ROOT)/Proc/IDS
AGESA_INC += -I$(AGESA_ROOT)/Proc/IDS/Family
AGESA_INC += -I$(AGESA_ROOT)/Proc/IDS/Family/0x16
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Common
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbGfxConfig
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbPcieConfig
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbGfxInitLibV1
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbPcieInitLibV1
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbNbInitLibV1
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbInitKB
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbSbLib
AGESA_INC += -I$(AGESA_ROOT)/Proc/IDS/Family/0x16/KB
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbCommonLib
AGESA_INC += -I$(AGESA_ROOT)/Proc/Mem/Main
AGESA_INC += -I$(AGESA_ROOT)/Proc/IDS/Library
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbNbInitLibV4
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbTable
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbPcieInitLibV4
AGESA_INC += -I$(AGESA_ROOT)/Proc/Fch
AGESA_INC += -I$(AGESA_ROOT)/Proc/Fch/Common
AGESA_INC += -I$(AGESA_ROOT)/Proc/IDS/Debug
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbPcieAspm
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbSmuLibV7
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbNbInitLibV5
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbPcieTrainingV2
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbPcieInitLibV5
AGESA_INC += -I$(AGESA_ROOT)/Proc/Mem/Feat/CRAT
AGESA_INC += -I$(AGESA_ROOT)/Proc/GNB/Modules/GnbGfxIntTableV3
AGESA_INC += -I$(AGESA_ROOT)/Proc/Mem/Feat/RDWR2DTRAINING

AGESA_INC += -I$(src)/southbridge/amd/agesa/hudson

CFLAGS_x86_32 += -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing
CFLAGS_x86_64 += -march=k8-sse3 -mtune=k8-sse3 -fno-zero-initialized-in-bss -fno-strict-aliasing


export AGESA_ROOT := $(AGESA_ROOT)
export AGESA_INC  := $(AGESA_INC)
CPPFLAGS_x86_32 += $(AGESA_INC)
CPPFLAGS_x86_64 += $(AGESA_INC)

#######################################################################



libagesa-y += Legacy/Proc/agesaCallouts.c
libagesa-y += Legacy/Proc/Dispatcher.c
libagesa-y += Legacy/Proc/hobTransfer.c
libagesa-y += Proc/Common/AmdInitEarly.c
libagesa-y += Proc/Common/AmdInitEnv.c
libagesa-y += Proc/Common/AmdInitLate.c
libagesa-y += Proc/Common/AmdInitMid.c
libagesa-y += Proc/Common/AmdInitPost.c
libagesa-y += Proc/Common/AmdInitReset.c
libagesa-y += Proc/Common/AmdInitResume.c
libagesa-y += Proc/Common/AmdLateRunApTask.c
libagesa-y += Proc/Common/AmdS3LateRestore.c
libagesa-y += Proc/Common/AmdS3Save.c
libagesa-y += Proc/Common/CommonInits.c
libagesa-y += Proc/Common/CommonReturns.c
libagesa-y += Proc/Common/CreateStruct.c
libagesa-y += Proc/Common/S3RestoreState.c
libagesa-y += Proc/Common/S3SaveState.c
libagesa-y += Proc/CPU/cahaltasm.S
libagesa-y += Proc/CPU/cahalt.c
libagesa-y += Proc/CPU/cpuApicUtilities.c
libagesa-y += Proc/CPU/cpuBist.c
libagesa-y += Proc/CPU/cpuEarlyInit.c
libagesa-y += Proc/CPU/cpuEventLog.c
libagesa-y += Proc/CPU/cpuFamilyTranslation.c
libagesa-y += Proc/CPU/cpuGeneralServices.c
libagesa-y += Proc/CPU/cpuLateInit.c
libagesa-y += Proc/CPU/cpuMicrocodePatch.c
libagesa-y += Proc/CPU/cpuPostInit.c
libagesa-y += Proc/CPU/cpuPowerMgmt.c
libagesa-y += Proc/CPU/cpuPowerMgmtSingleSocket.c
libagesa-y += Proc/CPU/cpuWarmReset.c
libagesa-y += Proc/CPU/Family/0x16/cpuF16Apm.c
libagesa-y += Proc/CPU/Family/0x16/cpuF16BrandId.c
libagesa-y += Proc/CPU/Family/0x16/cpuF16CacheDefaults.c
libagesa-y += Proc/CPU/Family/0x16/cpuF16Dmi.c
libagesa-y += Proc/CPU/Family/0x16/cpuF16MmioMap.c
libagesa-y += Proc/CPU/Family/0x16/cpuF16MsrUnknownTables.c
libagesa-y += Proc/CPU/Family/0x16/cpuF16PciUnknownTables.c
libagesa-y += Proc/CPU/Family/0x16/cpuF16Utilities.c
libagesa-y += Proc/CPU/Family/0x16/cpuF16WheaInitDataTables.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbC6State.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbCacheFlushOnHalt.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbCoreAfterReset.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbCpb.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbDmi.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbEquivalenceTable.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbHtc.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbInitEarlyTable.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbIoCstate.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbLogicalIdTables.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbId7001MicrocodePatch.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbMicrocodePatchTables.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbMsrTables.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbNbAfterReset.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbPciTables.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbPowerCheck.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbPowerMgmtSystemTables.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbPsi.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbPstate.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbSharedMsrTable.c
libagesa-y += Proc/CPU/Family/0x16/KB/F16KbUtilities.c
libagesa-y += Proc/CPU/Feature/cpuApm.c
libagesa-y += Proc/CPU/Feature/cpuC6State.c
libagesa-y += Proc/CPU/Feature/cpuCacheFlushOnHalt.c
libagesa-y += Proc/CPU/Feature/cpuCacheInit.c
libagesa-y += Proc/CPU/Feature/cpuCdit.c
libagesa-y += Proc/CPU/Feature/cpuCoreLeveling.c
libagesa-y += Proc/CPU/Feature/cpuCpb.c
libagesa-y += Proc/CPU/Feature/cpuCrat.c
libagesa-y += Proc/CPU/Feature/cpuDmi.c
libagesa-y += Proc/CPU/Feature/cpuFeatureLeveling.c
libagesa-y += Proc/CPU/Feature/cpuFeatures.c
libagesa-y += Proc/CPU/Feature/cpuHtc.c
libagesa-y += Proc/CPU/Feature/cpuIoCstate.c
libagesa-y += Proc/CPU/Feature/cpuPsi.c
libagesa-y += Proc/CPU/Feature/cpuPstateGather.c
libagesa-y += Proc/CPU/Feature/cpuPstateLeveling.c
libagesa-y += Proc/CPU/Feature/cpuPstateTables.c
libagesa-y += Proc/CPU/Feature/cpuSlit.c
libagesa-y += Proc/CPU/Feature/cpuSrat.c
libagesa-y += Proc/CPU/Feature/cpuWhea.c
libagesa-y += Proc/CPU/heapManager.c
libagesa-y += Proc/CPU/S3.c
libagesa-y += Proc/CPU/Table.c
libagesa-y += Proc/GNB/Common/GnbLibFeatures.c
libagesa-y += Proc/GNB/GnbInitAtEarly.c
libagesa-y += Proc/GNB/GnbInitAtEnv.c
libagesa-y += Proc/GNB/GnbInitAtLate.c
libagesa-y += Proc/GNB/GnbInitAtMid.c
libagesa-y += Proc/GNB/GnbInitAtPost.c
libagesa-y += Proc/GNB/GnbInitAtReset.c
libagesa-y += Proc/GNB/GnbInitAtS3Save.c
libagesa-y += Proc/GNB/Modules/GnbCommonLib/GnbLib.c
libagesa-y += Proc/GNB/Modules/GnbCommonLib/GnbLibCpuAcc.c
libagesa-y += Proc/GNB/Modules/GnbCommonLib/GnbLibHeap.c
libagesa-y += Proc/GNB/Modules/GnbCommonLib/GnbLibIoAcc.c
libagesa-y += Proc/GNB/Modules/GnbCommonLib/GnbLibMemAcc.c
libagesa-y += Proc/GNB/Modules/GnbCommonLib/GnbLibPciAcc.c
libagesa-y += Proc/GNB/Modules/GnbCommonLib/GnbLibPci.c
libagesa-y += Proc/GNB/Modules/GnbCommonLib/GnbTimerLib.c
libagesa-y += Proc/GNB/Modules/GnbFamTranslation/GnbPcieTranslation.c
libagesa-y += Proc/GNB/Modules/GnbFamTranslation/GnbTranslation.c
libagesa-y += Proc/GNB/Modules/GnbGfxConfig/GfxConfigEnv.c
libagesa-y += Proc/GNB/Modules/GnbGfxConfig/GfxConfigLib.c
libagesa-y += Proc/GNB/Modules/GnbGfxConfig/GfxConfigMid.c
libagesa-y += Proc/GNB/Modules/GnbGfxConfig/GfxConfigPost.c
libagesa-y += Proc/GNB/Modules/GnbGfxInitLibV1/GfxCardInfo.c
libagesa-y += Proc/GNB/Modules/GnbGfxInitLibV1/GfxEnumConnectors.c
libagesa-y += Proc/GNB/Modules/GnbGfxInitLibV1/GnbGfxInitLibV1.c
libagesa-y += Proc/GNB/Modules/GnbGfxIntTableV3/GfxIntegratedInfoTable.c
libagesa-y += Proc/GNB/Modules/GnbGfxIntTableV3/GfxLibV3.c
libagesa-y += Proc/GNB/Modules/GnbGfxIntTableV3/GfxPwrPlayTable.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/AlibKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GfxEnvInitKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GfxGmcInitKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GfxIntegratedInfoTableKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GfxIntegratedInfoTableKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GfxLibKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GfxMidInitKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GfxPostInitKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GfxSamuInitKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GfxTablesKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GnbEarlyInitKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GnbEnvInitKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GnbF1TableKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GnbIommuTablesKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GnbMidInitKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GnbPostInitKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GnbRegisterAccKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GnbTablesKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GnbUraKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GnbUraKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/GnbUraTokenMapKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/PcieComplexDataKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/PcieConfigKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/PcieEarlyInitKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/PcieEnvInitKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/PcieLibKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/PcieMidInitKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/PciePostInitKB.c
libagesa-y += Proc/GNB/Modules/GnbInitKB/PcieTablesKB.c
libagesa-y += Proc/GNB/Modules/GnbIoapic/GnbIoapic.c
libagesa-y += Proc/GNB/Modules/GnbNbInitLibV4/GnbNbInitLibV4.c
libagesa-y += Proc/GNB/Modules/GnbNbInitLibV5/GnbNbInitLibV5.c
libagesa-y += Proc/GNB/Modules/GnbPcieAlibV2/PcieAlibV2.c
libagesa-y += Proc/GNB/Modules/GnbPcieAspm/PcieAspm.c
libagesa-y += Proc/GNB/Modules/GnbPcieClkPm/PcieClkPm.c
libagesa-y += Proc/GNB/Modules/GnbPcieConfig/GnbHandleLib.c
libagesa-y += Proc/GNB/Modules/GnbPcieConfig/PcieConfigData.c
libagesa-y += Proc/GNB/Modules/GnbPcieConfig/PcieConfigLib.c
libagesa-y += Proc/GNB/Modules/GnbPcieConfig/PcieInputParser.c
libagesa-y += Proc/GNB/Modules/GnbPcieConfig/PcieMapTopology.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV1/PcieAspmBlackList.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV1/PciePifServices.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV1/PciePortRegAcc.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV1/PciePortServices.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV1/PcieTimer.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV1/PcieTopologyServices.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV1/PcieUtilityLib.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV1/PcieWrapperRegAcc.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV4/PciePortServicesV4.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV4/PcieWrapperServicesV4.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV5/PciePhyServicesV5.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV5/PciePifServicesV5.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV5/PciePortServicesV5.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV5/PcieSiliconServicesV5.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV5/PcieTopologyServicesV5.c
libagesa-y += Proc/GNB/Modules/GnbPcieInitLibV5/PcieWrapperServicesV5.c
libagesa-y += Proc/GNB/Modules/GnbPcieMaxPayload/PcieMaxPayload.c
libagesa-y += Proc/GNB/Modules/GnbPcieTrainingV2/PcieTrainingV2.c
libagesa-y += Proc/GNB/Modules/GnbPcieTrainingV2/PcieWorkaroundsV2.c
libagesa-y += Proc/GNB/Modules/GnbSbLib/GnbSbLib.c
libagesa-y += Proc/GNB/Modules/GnbSbLib/GnbSbPcie.c
libagesa-y += Proc/GNB/Modules/GnbScsLibV1/GnbScsLibV1.c
libagesa-y += Proc/GNB/Modules/GnbSmuLibV7/GnbSmuInitLibV7.c
libagesa-y += Proc/GNB/Modules/GnbSSocketLib/GnbSSocketLib.c
libagesa-y += Proc/GNB/Modules/GnbSview/GnbSview.c
libagesa-y += Proc/GNB/Modules/GnbTable/GnbTable.c
libagesa-y += Proc/GNB/Modules/GnbUraLibV1/GnbUraLibV1.c
libagesa-y += Proc/HT/Fam16/htNbFam16.c
libagesa-y += Proc/HT/Fam16/htNbUtilitiesFam16.c
libagesa-y += Proc/HT/htFeat.c
libagesa-y += Proc/HT/htInterface.c
libagesa-y += Proc/HT/htInterfaceCoherent.c
libagesa-y += Proc/HT/htInterfaceGeneral.c
libagesa-y += Proc/HT/htInterfaceNonCoherent.c
libagesa-y += Proc/HT/htMain.c
libagesa-y += Proc/HT/htNb.c
libagesa-y += Proc/HT/htNotify.c
libagesa-y += Proc/IDS/Debug/IdsDebug.c
libagesa-y += Proc/IDS/Debug/IdsDebugPrint.c
libagesa-y += Proc/IDS/Debug/IdsDpHdtout.c
libagesa-y += Proc/IDS/Debug/IdsDpSerial.c
libagesa-y += Proc/IDS/Family/0x16/KB/IdsF16KbAllService.c
libagesa-y += Proc/IDS/Library/IdsLib.c
libagesa-y += Proc/Mem/Ardk/ma.c
libagesa-y += Proc/Mem/Feat/CSINTLV/mfcsi.c
libagesa-y += Proc/Mem/Feat/DMI/mfDMI.c
libagesa-y += Proc/Mem/Feat/ECC/mfecc.c
libagesa-y += Proc/Mem/Feat/ECC/mfemp.c
libagesa-y += Proc/Mem/Feat/EXCLUDIMM/mfdimmexclud.c
libagesa-y += Proc/Mem/Feat/IDENDIMM/mfidendimm.c
libagesa-y += Proc/Mem/Feat/LVDDR3/mflvddr3.c
libagesa-y += Proc/Mem/Feat/MEMCLR/mfmemclr.c
libagesa-y += Proc/Mem/Feat/ODTHERMAL/mfodthermal.c
libagesa-y += Proc/Mem/Feat/PARTRN/mfParallelTraining.c
libagesa-y += Proc/Mem/Feat/PARTRN/mfStandardTraining.c
libagesa-y += Proc/Mem/Feat/RDWR2DTRAINING/KB/mfRdWr2DKb.c
libagesa-y += Proc/Mem/Feat/RDWR2DTRAINING/mfRdDqs2DTraining.c
libagesa-y += Proc/Mem/Feat/RDWR2DTRAINING/mfRdWr2DEyeRimSearch.c
libagesa-y += Proc/Mem/Feat/RDWR2DTRAINING/mfRdWr2DPatternGeneration.c
libagesa-y += Proc/Mem/Feat/RDWR2DTRAINING/mfRdWr2DTraining.c
libagesa-y += Proc/Mem/Feat/S3/mfs3.c
libagesa-y += Proc/Mem/Feat/TABLE/mftds.c
libagesa-y += Proc/Mem/Main/KB/mmflowkb.c
libagesa-y += Proc/Mem/Main/mdef.c
libagesa-y += Proc/Mem/Main/merrhdl.c
libagesa-y += Proc/Mem/Main/minit.c
libagesa-y += Proc/Mem/Main/mm.c
libagesa-y += Proc/Mem/Main/mmConditionalPso.c
libagesa-y += Proc/Mem/Main/mmEcc.c
libagesa-y += Proc/Mem/Main/mmExcludeDimm.c
libagesa-y += Proc/Mem/Main/mmflow.c
libagesa-y += Proc/Mem/Main/mmLvDdr3.c
libagesa-y += Proc/Mem/Main/mmMemClr.c
libagesa-y += Proc/Mem/Main/mmMemRestore.c
libagesa-y += Proc/Mem/Main/mmNodeInterleave.c
libagesa-y += Proc/Mem/Main/mmOnlineSpare.c
libagesa-y += Proc/Mem/Main/mmParallelTraining.c
libagesa-y += Proc/Mem/Main/mmStandardTraining.c
libagesa-y += Proc/Mem/Main/mmUmaAlloc.c
libagesa-y += Proc/Mem/Main/mu.c
libagesa-y += Proc/Mem/Main/muc.c
libagesa-y += Proc/Mem/NB/KB/mndctkb.c
libagesa-y += Proc/Mem/NB/KB/mnflowkb.c
libagesa-y += Proc/Mem/NB/KB/mnidendimmkb.c
libagesa-y += Proc/Mem/NB/KB/mnkb.c
libagesa-y += Proc/Mem/NB/KB/mnmctkb.c
libagesa-y += Proc/Mem/NB/KB/mnotkb.c
libagesa-y += Proc/Mem/NB/KB/mnphykb.c
libagesa-y += Proc/Mem/NB/KB/mnregkb.c
libagesa-y += Proc/Mem/NB/KB/mns3kb.c
libagesa-y += Proc/Mem/NB/mn.c
libagesa-y += Proc/Mem/NB/mndct.c
libagesa-y += Proc/Mem/NB/mnfeat.c
libagesa-y += Proc/Mem/NB/mnflow.c
libagesa-y += Proc/Mem/NB/mnmct.c
libagesa-y += Proc/Mem/NB/mnphy.c
libagesa-y += Proc/Mem/NB/mnreg.c
libagesa-y += Proc/Mem/NB/mnS3.c
libagesa-y += Proc/Mem/NB/mntrain3.c
libagesa-y += Proc/Mem/Ps/KB/FT3/mpSkbft3.c
libagesa-y += Proc/Mem/Ps/KB/mpkb3.c
libagesa-y += Proc/Mem/Ps/KB/mpSkb3.c
libagesa-y += Proc/Mem/Ps/KB/mpUkb3.c
libagesa-y += Proc/Mem/Ps/mp.c
libagesa-y += Proc/Mem/Ps/mpmaxfreq.c
libagesa-y += Proc/Mem/Ps/mpmr0.c
libagesa-y += Proc/Mem/Ps/mpodtpat.c
libagesa-y += Proc/Mem/Ps/mprtt.c
libagesa-y += Proc/Mem/Ps/mps2d.c
libagesa-y += Proc/Mem/Ps/mpsao.c
libagesa-y += Proc/Mem/Tech/DDR3/mt3.c
libagesa-y += Proc/Mem/Tech/DDR3/mtot3.c
libagesa-y += Proc/Mem/Tech/DDR3/mtrci3.c
libagesa-y += Proc/Mem/Tech/DDR3/mtsdi3.c
libagesa-y += Proc/Mem/Tech/DDR3/mtspd3.c
libagesa-y += Proc/Mem/Tech/DDR3/mttecc3.c
libagesa-y += Proc/Mem/Tech/DDR3/mttwl3.c
libagesa-y += Proc/Mem/Tech/mt.c
libagesa-y += Proc/Mem/Tech/mthdi.c
libagesa-y += Proc/Mem/Tech/mttdimbt.c
libagesa-y += Proc/Mem/Tech/mttecc.c
libagesa-y += Proc/Mem/Tech/mttEdgeDetect.c
libagesa-y += Proc/Mem/Tech/mtthrc.c
libagesa-y += Proc/Mem/Tech/mtthrcSeedTrain.c
libagesa-y += Proc/Mem/Tech/mttml.c
libagesa-y += Proc/Mem/Tech/mttoptsrc.c
libagesa-y += Proc/Mem/Tech/mttRdDqs2DEyeRimSearch.c
libagesa-y += Proc/Mem/Tech/mttRdDqs2DTraining.c
libagesa-y += Proc/Mem/Tech/mttsrc.c

libagesa-y += Proc/Fch/Azalia/AzaliaEnv.c
libagesa-y += Proc/Fch/Azalia/AzaliaLate.c
libagesa-y += Proc/Fch/Azalia/AzaliaMid.c
libagesa-y += Proc/Fch/Azalia/AzaliaReset.c
libagesa-y += Proc/Fch/Common/AcpiLib.c
libagesa-y += Proc/Fch/Common/FchCommon.c
libagesa-y += Proc/Fch/Common/FchLib.c
libagesa-y += Proc/Fch/Common/FchPeLib.c
libagesa-y += Proc/Fch/Common/MemLib.c
libagesa-y += Proc/Fch/Common/PciLib.c
libagesa-y += Proc/Fch/HwAcpi/Family/Yangtze/YangtzeHwAcpiEnvService.c
libagesa-y += Proc/Fch/HwAcpi/Family/Yangtze/YangtzeHwAcpiLateService.c
libagesa-y += Proc/Fch/HwAcpi/Family/Yangtze/YangtzeHwAcpiMidService.c
libagesa-y += Proc/Fch/HwAcpi/Family/Yangtze/YangtzeSSService.c
libagesa-y += Proc/Fch/HwAcpi/HwAcpiEnv.c
libagesa-y += Proc/Fch/HwAcpi/HwAcpiLate.c
libagesa-y += Proc/Fch/HwAcpi/HwAcpiMid.c
libagesa-y += Proc/Fch/HwAcpi/HwAcpiReset.c
libagesa-y += Proc/Fch/Hwm/Family/Yangtze/YangtzeHwmEnvService.c
libagesa-y += Proc/Fch/Hwm/Family/Yangtze/YangtzeHwmLateService.c
libagesa-y += Proc/Fch/Hwm/HwmLate.c
libagesa-y += Proc/Fch/Ide/IdeEnv.c
libagesa-y += Proc/Fch/Ide/IdeLate.c
libagesa-y += Proc/Fch/Ide/IdeMid.c
libagesa-y += Proc/Fch/Imc/Family/Yangtze/YangtzeImcService.c
libagesa-y += Proc/Fch/Imc/FchEcEnv.c
libagesa-y += Proc/Fch/Imc/FchEcLate.c
libagesa-y += Proc/Fch/Imc/FchEcMid.c
libagesa-y += Proc/Fch/Imc/ImcEnv.c
libagesa-y += Proc/Fch/Imc/ImcLate.c
libagesa-y += Proc/Fch/Imc/ImcLib.c
libagesa-y += Proc/Fch/Imc/ImcMid.c
libagesa-y += Proc/Fch/Imc/ImcReset.c
libagesa-y += Proc/Fch/Interface/Family/Yangtze/EnvDefYangtze.c
libagesa-y += Proc/Fch/Interface/Family/Yangtze/ResetDefYangtze.c
libagesa-y += Proc/Fch/Interface/FchInitEnv.c
libagesa-y += Proc/Fch/Interface/FchInitLate.c
libagesa-y += Proc/Fch/Interface/FchInitMid.c
libagesa-y += Proc/Fch/Interface/FchInitReset.c
libagesa-y += Proc/Fch/Interface/FchInitS3.c
libagesa-y += Proc/Fch/Interface/FchTaskLauncher.c
libagesa-y += Proc/Fch/Interface/InitEnvDef.c
libagesa-y += Proc/Fch/Interface/InitResetDef.c
libagesa-y += Proc/Fch/Pcie/AbEnv.c
libagesa-y += Proc/Fch/Pcie/AbLate.c
libagesa-y += Proc/Fch/Pcie/AbMid.c
libagesa-y += Proc/Fch/Pcie/AbReset.c
libagesa-y += Proc/Fch/Pcie/Family/Yangtze/YangtzeAbEnvService.c
libagesa-y += Proc/Fch/Pcie/Family/Yangtze/YangtzeAbResetService.c
libagesa-y += Proc/Fch/Pcie/Family/Yangtze/YangtzeAbService.c
libagesa-y += Proc/Fch/Pcie/PcieEnv.c
libagesa-y += Proc/Fch/Pcie/PcieEnv.c
libagesa-y += Proc/Fch/Pcie/PcieLate.c
libagesa-y += Proc/Fch/Pcie/PcieMid.c
libagesa-y += Proc/Fch/Pcie/PcieReset.c
libagesa-y += Proc/Fch/Sata/AhciEnv.c
libagesa-y += Proc/Fch/Sata/AhciLate.c
libagesa-y += Proc/Fch/Sata/AhciLib.c
libagesa-y += Proc/Fch/Sata/AhciMid.c
libagesa-y += Proc/Fch/Sata/Family/Yangtze/YangtzeSataEnvService.c
libagesa-y += Proc/Fch/Sata/Family/Yangtze/YangtzeSataResetService.c
libagesa-y += Proc/Fch/Sata/Family/Yangtze/YangtzeSataService.c
libagesa-y += Proc/Fch/Sata/Ide2AhciEnv.c
libagesa-y += Proc/Fch/Sata/Ide2AhciLate.c
libagesa-y += Proc/Fch/Sata/Ide2AhciLib.c
libagesa-y += Proc/Fch/Sata/Ide2AhciMid.c
libagesa-y += Proc/Fch/Sata/RaidEnv.c
libagesa-y += Proc/Fch/Sata/RaidLate.c
libagesa-y += Proc/Fch/Sata/RaidLib.c
libagesa-y += Proc/Fch/Sata/RaidMid.c
libagesa-y += Proc/Fch/Sata/SataEnv.c
libagesa-y += Proc/Fch/Sata/SataEnvLib.c
libagesa-y += Proc/Fch/Sata/SataIdeEnv.c
libagesa-y += Proc/Fch/Sata/SataIdeLate.c
libagesa-y += Proc/Fch/Sata/SataIdeLib.c
libagesa-y += Proc/Fch/Sata/SataIdeMid.c
libagesa-y += Proc/Fch/Sata/SataLate.c
libagesa-y += Proc/Fch/Sata/SataLib.c
libagesa-y += Proc/Fch/Sata/SataMid.c
libagesa-y += Proc/Fch/Sata/SataReset.c
libagesa-y += Proc/Fch/Sd/Family/Yangtze/YangtzeSdEnvService.c
libagesa-y += Proc/Fch/Sd/Family/Yangtze/YangtzeSdResetService.c
libagesa-y += Proc/Fch/Sd/Family/Yangtze/YangtzeSdService.c
libagesa-y += Proc/Fch/Sd/SdEnv.c
libagesa-y += Proc/Fch/Sd/SdLate.c
libagesa-y += Proc/Fch/Sd/SdMid.c
libagesa-y += Proc/Fch/Spi/Family/Yangtze/YangtzeLpcEnvService.c
libagesa-y += Proc/Fch/Spi/Family/Yangtze/YangtzeLpcResetService.c
libagesa-y += Proc/Fch/Spi/LpcEnv.c
libagesa-y += Proc/Fch/Spi/LpcLate.c
libagesa-y += Proc/Fch/Spi/LpcMid.c
libagesa-y += Proc/Fch/Spi/LpcReset.c
libagesa-y += Proc/Fch/Spi/SpiEnv.c
libagesa-y += Proc/Fch/Spi/SpiLate.c
libagesa-y += Proc/Fch/Spi/SpiMid.c
libagesa-y += Proc/Fch/Spi/SpiReset.c
libagesa-y += Proc/Fch/Usb/EhciEnv.c
libagesa-y += Proc/Fch/Usb/EhciLate.c
libagesa-y += Proc/Fch/Usb/EhciMid.c
libagesa-y += Proc/Fch/Usb/EhciReset.c
libagesa-y += Proc/Fch/Usb/Family/Yangtze/YangtzeEhciEnvService.c
libagesa-y += Proc/Fch/Usb/Family/Yangtze/YangtzeEhciLateService.c
libagesa-y += Proc/Fch/Usb/Family/Yangtze/YangtzeEhciMidService.c
libagesa-y += Proc/Fch/Usb/Family/Yangtze/YangtzeOhciEnvService.c
libagesa-y += Proc/Fch/Usb/Family/Yangtze/YangtzeOhciLateService.c
libagesa-y += Proc/Fch/Usb/Family/Yangtze/YangtzeOhciMidService.c
libagesa-y += Proc/Fch/Usb/Family/Yangtze/YangtzeXhciEnvService.c
libagesa-y += Proc/Fch/Usb/Family/Yangtze/YangtzeXhciLateService.c
libagesa-y += Proc/Fch/Usb/Family/Yangtze/YangtzeXhciMidService.c
libagesa-y += Proc/Fch/Usb/Family/Yangtze/YangtzeXhciResetService.c
libagesa-y += Proc/Fch/Usb/OhciEnv.c
libagesa-y += Proc/Fch/Usb/OhciLate.c
libagesa-y += Proc/Fch/Usb/OhciMid.c
libagesa-y += Proc/Fch/Usb/OhciReset.c
libagesa-y += Proc/Fch/Usb/UsbEnv.c
libagesa-y += Proc/Fch/Usb/UsbLate.c
libagesa-y += Proc/Fch/Usb/UsbMid.c
libagesa-y += Proc/Fch/Usb/UsbReset.c
libagesa-y += Proc/Fch/Usb/XhciEnv.c
libagesa-y += Proc/Fch/Usb/XhciLate.c
libagesa-y += Proc/Fch/Usb/XhciMid.c
libagesa-y += Proc/Fch/Usb/XhciReset.c

$(obj)/libagesa.fam16kb.a: $$(libagesa-objs)
	@printf "    AGESA        $(subst $(obj)/,,$(@))\n"
	ar rcs $@ $+

romstage-libs  += $(obj)/libagesa.fam16kb.a
ramstage-libs  += $(obj)/libagesa.fam16kb.a
